=begin
#Onfido API v3.6

#The Onfido API (v3.6)

The version of the OpenAPI document: v3.6

Generated by: https://openapi-generator.tech
Generator version: 7.11.0

=end

require 'date'
require 'time'

module Onfido
  class Webhook
    # Determine if the webhook is active.
    attr_accessor :enabled

    # The events that will be published to the webhook. If the events parameter is omitted all the events will be subscribed. 
    attr_accessor :events

    # The environments from which the webhook will receive events. Allowed values are “sandbox” and “live”. If the environments parameter is omitted the webhook will receive events from both environments. 
    attr_accessor :environments

    # Webhook version used to control the payload object when sending webhooks.
    attr_accessor :payload_version

    # Determines if the webhook will fetch OAuth access tokens to send in the Authorization header.
    attr_accessor :oauth_enabled

    # The url to fetch the OAuth access token using client credentials grant.
    attr_accessor :oauth_server_url

    # The client id to authenticate the client credentials grant.
    attr_accessor :oauth_server_client_id

    # The client secret to authenticate the client credentials grant.
    attr_accessor :oauth_server_client_secret

    # The scopes to be sent when requesting the access token.
    attr_accessor :oauth_server_scope

    # The unique identifier of the webhook.
    attr_accessor :id

    # The url that will listen to notifications (must be https).
    attr_accessor :url

    # Webhook secret token used to sign the webhook's payload.
    attr_accessor :token

    # The API endpoint to retrieve the webhook.
    attr_accessor :href

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'enabled' => :'enabled',
        :'events' => :'events',
        :'environments' => :'environments',
        :'payload_version' => :'payload_version',
        :'oauth_enabled' => :'oauth_enabled',
        :'oauth_server_url' => :'oauth_server_url',
        :'oauth_server_client_id' => :'oauth_server_client_id',
        :'oauth_server_client_secret' => :'oauth_server_client_secret',
        :'oauth_server_scope' => :'oauth_server_scope',
        :'id' => :'id',
        :'url' => :'url',
        :'token' => :'token',
        :'href' => :'href'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'enabled' => :'Boolean',
        :'events' => :'Array<WebhookEventType>',
        :'environments' => :'Array<String>',
        :'payload_version' => :'Integer',
        :'oauth_enabled' => :'Boolean',
        :'oauth_server_url' => :'String',
        :'oauth_server_client_id' => :'String',
        :'oauth_server_client_secret' => :'String',
        :'oauth_server_scope' => :'String',
        :'id' => :'String',
        :'url' => :'String',
        :'token' => :'String',
        :'href' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # List of class defined in allOf (OpenAPI v3)
    def self.openapi_all_of
      [
      :'WebhookResponse',
      :'WebhookShared'
      ]
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Onfido::Webhook` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Onfido::Webhook`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'enabled')
        self.enabled = attributes[:'enabled']
      end

      if attributes.key?(:'events')
        if (value = attributes[:'events']).is_a?(Array)
          self.events = value
        end
      end

      if attributes.key?(:'environments')
        if (value = attributes[:'environments']).is_a?(Array)
          self.environments = value
        end
      end

      if attributes.key?(:'payload_version')
        self.payload_version = attributes[:'payload_version']
      end

      if attributes.key?(:'oauth_enabled')
        self.oauth_enabled = attributes[:'oauth_enabled']
      end

      if attributes.key?(:'oauth_server_url')
        self.oauth_server_url = attributes[:'oauth_server_url']
      end

      if attributes.key?(:'oauth_server_client_id')
        self.oauth_server_client_id = attributes[:'oauth_server_client_id']
      end

      if attributes.key?(:'oauth_server_client_secret')
        self.oauth_server_client_secret = attributes[:'oauth_server_client_secret']
      end

      if attributes.key?(:'oauth_server_scope')
        self.oauth_server_scope = attributes[:'oauth_server_scope']
      end

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      else
        self.id = nil
      end

      if attributes.key?(:'url')
        self.url = attributes[:'url']
      end

      if attributes.key?(:'token')
        self.token = attributes[:'token']
      end

      if attributes.key?(:'href')
        self.href = attributes[:'href']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      warn '[DEPRECATED] the `list_invalid_properties` method is obsolete'
      invalid_properties = Array.new
      if @id.nil?
        invalid_properties.push('invalid value for "id", id cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      warn '[DEPRECATED] the `valid?` method is obsolete'
      return false if @id.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          enabled == o.enabled &&
          events == o.events &&
          environments == o.environments &&
          payload_version == o.payload_version &&
          oauth_enabled == o.oauth_enabled &&
          oauth_server_url == o.oauth_server_url &&
          oauth_server_client_id == o.oauth_server_client_id &&
          oauth_server_client_secret == o.oauth_server_client_secret &&
          oauth_server_scope == o.oauth_server_scope &&
          id == o.id &&
          url == o.url &&
          token == o.token &&
          href == o.href
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [enabled, events, environments, payload_version, oauth_enabled, oauth_server_url, oauth_server_client_id, oauth_server_client_secret, oauth_server_scope, id, url, token, href].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      transformed_hash = {}
      openapi_types.each_pair do |key, type|
        if attributes.key?(attribute_map[key]) && attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = nil
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            transformed_hash["#{key}"] = attributes[attribute_map[key]].map { |v| _deserialize($1, v) }
          end
        elsif !attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = _deserialize(type, attributes[attribute_map[key]])
        end
      end
      new(transformed_hash)
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def self._deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = Onfido.const_get(type)
        klass.respond_to?(:openapi_any_of) || klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
